<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@gmail.com)
* Core function:
* session.php: last changed 18/04/2010 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

/* Create new object of class */
$ses_class = new session();
$ses_class->ses_table = $dbprefix . "sessions";

/* Change the save_handler to use the class functions */
session_set_save_handler(array (
	& $ses_class,
	'_open'
), array (
	& $ses_class,
	'_close'
), array (
	& $ses_class,
	'_read'
), array (
	& $ses_class,
	'_write'
), array (
	& $ses_class,
	'_destroy'
), array (
	& $ses_class,
	'_gc'
));

//added aftre switching to mysqli 
register_shutdown_function('session_write_close');
/* Start the session */
session_start();
ini_set('session.name', 'hash'); # try to hide the session name..
date_default_timezone_set("UTC"); 

if (!isset($_SESSION['ip']))
	$_SESSION['ip'] = $_SERVER['REMOTE_ADDR'];
if ($_SESSION['ip'] != $_SERVER['REMOTE_ADDR']) {
	//trigger_error("Session Hijacking detected!", E_USER_WARNING);
}

class session
{
	/* Define the mysql table you wish to use with
	   this class, this table MUST exist. */
	var $ses_table;

	/* Open session */
	function _open($path, $name)
	{
		/* just define this function. */
		return TRUE;
	}

	/* Close session */
	function _close()
	{
		/* This is used for a manual call of the
		   session gc function */
		$this->_gc(0);
		return TRUE;
	}

	/* Read session data from database */
	function _read($ses_id)
	{
		global $db;
		$session_sql = "SELECT * FROM " . $this->ses_table . " WHERE ses_id = '$ses_id'";
		$session_res = @ mysqli_query($db, $session_sql);
		if (!$session_res)
		{
			return '';
		}

		$session_num = @ mysqli_num_rows($session_res);
		if ($session_num > 0)
		{
			$session_row = mysqli_fetch_array($session_res);
			$ses_data = $session_row["ses_value"];
			return $ses_data;
		}
		else
		{
			return '';
		}
	}

	/* Write new data to database */
	function _write($ses_id, $data)
	{
		global $db;
		$session_sql = "UPDATE " . $this->ses_table . " SET ses_time='" . time() . "', ses_value='$data' WHERE ses_id='$ses_id'";
		$session_res = @ mysqli_query($db, $session_sql);
		if (!$session_res)
		{
			return FALSE;
		}
		if (mysqli_affected_rows($db))
		{
			return TRUE;
		}

		$session_sql = "INSERT INTO " . $this->ses_table . " (ses_id, ses_time, ses_start, ses_value)" . " VALUES ('$ses_id', '" . time() . "', '" . time() . "', '$data')";
		$session_res = @ mysqli_query($db, $session_sql);
		if (!$session_res)
		{
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}

	/* Destroy session record in database */
	function _destroy($ses_id)
	{
		global $db;
		$session_sql = "DELETE FROM " . $this->ses_table . " WHERE ses_id = '$ses_id'";
		$session_res = @ mysqli_query($db,$session_sql);
		if (!$session_res)
		{
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}

	/* Garbage collection, deletes old sessions */
	function _gc($life)
	{
		global $db;
		$ses_life = strtotime("-60 minutes");

		$session_sql = "DELETE FROM " . $this->ses_table . " WHERE ses_time < $ses_life";
		$session_res = @ mysqli_query($db, $session_sql);

		if (!$session_res)
		{
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
}
?>